#include <QtGui>
#include <QtWebKit>
#if QT_VERSION >= 0x050000
#include <QtWidgets>
#include <QtPrintSupport>
#include <QtWebKitWidgets>
#endif

static const QString HTML =
    "<html>"
    "<table border=\"1\">"
    "<tr>"
    "<td>Row 1, Column 1</td>"
    "<td>Row 1, Column 2</td>"
    "</tr>"
    "<tr>"
    "<td>Row 2, Column 1</td>"
    "<td>Row 2, Column 2</td>"
    "</tr>"
    "</table>"
    "</html>";

class PrintPreviewWidget : public QPrintPreviewWidget
{
    Q_OBJECT

public:
    explicit PrintPreviewWidget(QWidget *parent = 0)
     : QPrintPreviewWidget(m_printer = new QPrinter(QPrinter::HighResolution), parent)
    {
        connect(this, SIGNAL(paintRequested(QPrinter*)), this, SLOT(doPaint(QPrinter*)));
        m_view = new QWebView();
    }

    ~PrintPreviewWidget()
    {
        delete m_printer;
        delete m_view;
    }

public slots:
    void doPaint(QPrinter *printer)
    {
        m_view->setHtml(HTML);
        m_view->print(printer);
    }

private:
    QPrinter *m_printer;
    QWebView *m_view;
};

int main(int argc, char *argv[])
{
    QApplication a(argc, argv);

    PrintPreviewWidget w;
    w.resize(600, 600);
    w.show();

    return a.exec();
}

#include "moc_main.cpp"
